From c357e2add2a7ed022792229eb60ae1a967cbf436 Mon Sep 17 00:00:00 2001
From: Alyssa Rosenzweig <alyssa@collabora.com>
Date: Wed, 28 Jul 2021 17:38:12 -0400
Subject: [PATCH 2/2] intel/brw: Call opt_shrink_vectors after opt_cse

Required to avoid duplicating I/O.

Signed-off-by: Alyssa Rosenzweig <alyssa@collabora.com>
---
 src/intel/compiler/brw_nir.c | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

diff --git a/src/intel/compiler/brw_nir.c b/src/intel/compiler/brw_nir.c
index dc09dcbd24c..a867c3ad39f 100644
--- a/src/intel/compiler/brw_nir.c
+++ b/src/intel/compiler/brw_nir.c
@@ -602,8 +602,6 @@ brw_nir_optimize(nir_shader *nir, const struct brw_compiler *compiler,
 
       if (is_scalar) {
          OPT(nir_lower_alu_to_scalar, NULL, NULL);
-      } else {
-         OPT(nir_opt_shrink_vectors, true);
       }
 
       OPT(nir_copy_prop);
@@ -615,6 +613,11 @@ brw_nir_optimize(nir_shader *nir, const struct brw_compiler *compiler,
       OPT(nir_copy_prop);
       OPT(nir_opt_dce);
       OPT(nir_opt_cse);
+
+      if (!is_scalar) {
+         OPT(nir_opt_shrink_vectors, true);
+      }
+
       OPT(nir_opt_combine_stores, nir_var_all);
 
       /* Passing 0 to the peephole select pass causes it to convert
-- 
2.30.2

